diff --git a/usr/local/www/diag_backup.php b/usr/local/www/diag_backup.php
index 741dd666c1..da9ee6ab30 100644
--- a/usr/local/www/diag_backup.php
+++ b/usr/local/www/diag_backup.php
@@ -3,7 +3,7 @@
 /*
 	diag_backup.php
 	Copyright (C) 2004-2009 Scott Ullrich
-        Copyright (C) 2013-2014 Electric Sheep Fencing, LP
+	Copyright (C) 2013-2014 Electric Sheep Fencing, LP
 	All rights reserved.
 
 	originally part of m0n0wall (http://m0n0.ch/wall)
@@ -178,32 +178,33 @@ function check_and_returnif_section_exists($section) {
 function spit_out_select_items($name, $showall) {
 	global $config;
 
-	$areas = array("aliases" => gettext("Aliases"),
-		       "captiveportal" => gettext("Captive Portal"),
-		       "voucher" => gettext("Captive Portal Vouchers"),
-		       "dnsmasq" => gettext("DNS Forwarder"),
-		       "dhcpd" => gettext("DHCP Server"),
-		       "dhcpdv6" => gettext("DHCPv6 Server"),
-		       "filter" => gettext("Firewall Rules"),
-		       "interfaces" => gettext("Interfaces"),
-		       "ipsec" => gettext("IPSEC"),
-		       "nat" => gettext("NAT"),
-		       "openvpn" => gettext("OpenVPN"),
-		       "installedpackages" => gettext("Package Manager"),
-		       "pptpd" => gettext("PPTP Server"),
-		       "rrddata" => gettext("RRD Data"),
-		       "cron" => gettext("Scheduled Tasks"),
-		       "syslog" => gettext("Syslog"),
-		       "system" => gettext("System"),
-		       "staticroutes" => gettext("Static routes"),
-		       "sysctl" => gettext("System tunables"),
-		       "snmpd" => gettext("SNMP Server"),
-		       "shaper" => gettext("Traffic Shaper"),
-		       "vlans" => gettext("VLANS"),
-		       "wol" => gettext("Wake on LAN")
-		);
-
-	$select  = "<select name=\"{$name}\" id=\"{$name}\">";
+	$areas = array(
+		"aliases" => gettext("Aliases"),
+		"captiveportal" => gettext("Captive Portal"),
+		"voucher" => gettext("Captive Portal Vouchers"),
+		"dnsmasq" => gettext("DNS Forwarder"),
+		"dhcpd" => gettext("DHCP Server"),
+		"dhcpdv6" => gettext("DHCPv6 Server"),
+		"filter" => gettext("Firewall Rules"),
+		"interfaces" => gettext("Interfaces"),
+		"ipsec" => gettext("IPSEC"),
+		"nat" => gettext("NAT"),
+		"openvpn" => gettext("OpenVPN"),
+		"installedpackages" => gettext("Package Manager"),
+		"pptpd" => gettext("PPTP Server"),
+		"rrddata" => gettext("RRD Data"),
+		"cron" => gettext("Scheduled Tasks"),
+		"syslog" => gettext("Syslog"),
+		"system" => gettext("System"),
+		"staticroutes" => gettext("Static routes"),
+		"sysctl" => gettext("System tunables"),
+		"snmpd" => gettext("SNMP Server"),
+		"shaper" => gettext("Traffic Shaper"),
+		"vlans" => gettext("VLANS"),
+		"wol" => gettext("Wake on LAN")
+	);
+
+	$select  = "<select name=\"{$name}\" id=\"{$name}\" multiple=\"multiple\">";
 	$select .= "<option value=\"\">" . gettext("ALL") . "</option>";
 
 	if($showall == true)
@@ -216,22 +217,7 @@ function spit_out_select_items($name, $showall) {
 
 	$select .= "</select>\n";
 
-	if ($name === "backuparea") {
-		$select .= <<<END_SCRIPT_BLOCK
-			<script type="text/javascript">
-			//<![CDATA[
-				jQuery(function (\$) {
-					$("#{$name}").change(function () {
-						backuparea_change(this);
-					}).trigger("change");
-				});
-			//]]>
-			</script>
-END_SCRIPT_BLOCK;
-	}
-
 	echo $select;
-
 }
 
 if ($_POST['apply']) {
@@ -594,132 +580,71 @@ $pgtitle = array(gettext("Diagnostics"),gettext("Backup/restore"));
 include("head.inc");
 
 ?>
+<body>
+<?php include("fbegin.inc")?>
+<?php if ($input_errors) print_input_errors($input_errors)?>
+<?php if ($savemsg) print_info_box($savemsg)?>
+<?php if (is_subsystem_dirty('restore')):?><br/>
+	<form action="reboot.php" method="post">
+		<input name="Submit" type="hidden" value="Yes" />
+		<?php print_info_box(gettext("The firewall configuration has been changed.") . "<br />" . gettext("The firewall is now rebooting."))?><br />
+	</form>
+<?php endif?>
+<?php
+	$tab_array = array();
+	$tab_array[0] = array(gettext("Config History"), false, "diag_confbak.php");
+	$tab_array[1] = array(gettext("Backup/Restore"), true, "diag_backup.php");
+	display_top_tabs($tab_array);
+?>
+	<div id="container">
+		<form class="form-horizontal" action="diag_backup.php" method="post" name="iform" enctype="multipart/form-data">
+			<h2><?=gettext("Backup configuration"); ?></h2>
+			<div class="form-group">
+				<label for="backuparea" class="col-sm-2 control-label"><?=gettext("Backup area"); ?></label>
+				<div class="col-sm-10">
+					<?php spit_out_select_items("backuparea", false)?>
+				</div>
+			</div>
 
-<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
-<?php include("fbegin.inc"); ?>
-<script type="text/javascript">
-//<![CDATA[
-
-function encrypt_change() {
+			<div class="form-group">
+				<label for="nopackages" class="col-sm-2 control-label"><?=gettext("Do not backup package information.")?></label>
+				<div class="col-sm-10">
+					<input name="nopackages" type="checkbox" />
+				</div>
+			</div>
 
-	if (!document.iform.encrypt.checked)
-		document.getElementById("encrypt_opts").style.display="none";
-	else
-		document.getElementById("encrypt_opts").style.display="";
-}
+			<div class="form-group">
+				<label for="donotbackuprrd" class="col-sm-2 control-label"><?=gettext("Do not backup RRD data (NOTE: RRD Data can consume 4+ megabytes of config.xml space!)")?></label>
+				<div class="col-sm-10">
+					<input name="donotbackuprrd" type="checkbox" checked="checked" />
+				</div>
+			</div>
 
-function decrypt_change() {
+			<div class="form-group">
+				<label for="encrypt" class="col-sm-2 control-label"><?=gettext("Encrypt this configuration file.")?></label>
+				<div class="col-sm-10">
+					<input name="encrypt" type="checkbox" data-toggle="collapse" href="#encryptOptions" aria-expanded="false" aria-controls="encryptOptions" />
 
-	if (!document.iform.decrypt.checked)
-		document.getElementById("decrypt_opts").style.display="none";
-	else
-		document.getElementById("decrypt_opts").style.display="";
-}
+					<div class="collapse"id="encryptOptions">
+						<input name="encrypt_password" type="password" placeholder="Password" /><br/>
+						<input name="encrypt_passconf" type="password" placeholder="Confirm password" />
+					</div>
+				</div>
+			</div>
 
-function backuparea_change(obj) {
-	if (obj.value == "rrddata") {
-		document.getElementById("nopackages").disabled      = true;
-		document.getElementById("dotnotbackuprrd").disabled = true;
-	} else {
-		document.getElementById("nopackages").disabled      = false;
-		document.getElementById("dotnotbackuprrd").disabled = false;
-	}
-}
-//]]>
-</script>
-
-<?php if ($input_errors) print_input_errors($input_errors); ?>
-<?php if ($savemsg) print_info_box($savemsg); ?>
-<?php if (is_subsystem_dirty('restore')): ?><br/>
-<form action="reboot.php" method="post">
-<input name="Submit" type="hidden" value="Yes" />
-<?php print_info_box(gettext("The firewall configuration has been changed.") . "<br />" . gettext("The firewall is now rebooting."));?><br />
+			<input name="Submit" type="submit" class="btn btn-default" value="<?=gettext("Download configuration as XML")?>" />
 </form>
-<?php endif; ?>
+
 <form action="diag_backup.php" method="post" name="iform" enctype="multipart/form-data">
-<table width="100%" border="0" cellspacing="0" cellpadding="0" summary="diag backup">
-	<tr>
-		<td>
-<?php
-		$tab_array = array();
-		$tab_array[0] = array(gettext("Config History"), false, "diag_confbak.php");
-		$tab_array[1] = array(gettext("Backup/Restore"), true, "diag_backup.php");
-		display_top_tabs($tab_array);
-?>
-		</td>
-	</tr>
-	<tr>
-		<td>
-			<div id="mainarea">
-			<table class="tabcont" align="center" width="100%" border="0" cellpadding="6" cellspacing="0" summary="main area">
 				<tr>
-					<td colspan="2" class="listtopic"><?=gettext("Backup configuration"); ?></td>
+					<td><?=gettext("Restore configuration")?></td>
 				</tr>
 				<tr>
-					<td width="22%" valign="baseline" class="vncell">&nbsp;</td>
-					<td width="78%" class="vtable">
-						<p><?=gettext("Click this button to download the system configuration in XML format."); ?><br /><br /> <?=gettext("Backup area:"); ?> <?php spit_out_select_items("backuparea", false); ?></p>
-						<table>
-							<tr>
-								<td>
-									<input name="nopackages" type="checkbox" class="formcheckbox" id="nopackages" />
-								</td>
-								<td>
-									<span class="vexpl"><?=gettext("Do not backup package information."); ?></span>
-								</td>
-							</tr>
-						</table>
-						<table>
-							<tr>
-								<td>
-									<input name="encrypt" type="checkbox" class="formcheckbox" id="nopackages" onclick="encrypt_change()" />
-								</td>
-								<td>
-									<span class="vexpl"><?=gettext("Encrypt this configuration file."); ?></span>
-								</td>
-							</tr>
-							<tr>
-								<td>
-									<input name="donotbackuprrd" type="checkbox" class="formcheckbox" id="dotnotbackuprrd" checked="checked" />
-								</td>
-								<td>
-									<span class="vexpl"><?=gettext("Do not backup RRD data (NOTE: RRD Data can consume 4+ megabytes of config.xml space!)"); ?></span>
-								</td>
-							</tr>
-						</table>
-						<table id="encrypt_opts">
-							<tr>
-								<td>
-									<span class="vexpl"><?=gettext("Password:"); ?> </span>
-								</td>
-								<td>
-									<input name="encrypt_password" type="password" class="formfld pwd" size="20" value="" />
-								</td>
-							</tr>
-							<tr>
-								<td>
-									<span class="vexpl"><?=gettext("confirm:"); ?> </span>
-								</td>
-								<td>
-									<input name="encrypt_passconf" type="password" class="formfld pwd" size="20" value="" />
-								</td>
-							</tr>
-						</table>
-						<p><input name="Submit" type="submit" class="formbtn" id="download" value="<?=gettext("Download configuration"); ?>" /></p>
-					</td>
-				</tr>
-				<tr>
-					<td colspan="2" class="list" height="12">&nbsp;</td>
-				</tr>
-				<tr>
-					<td colspan="2" class="listtopic"><?=gettext("Restore configuration"); ?></td>
-				</tr>
-				<tr>
-					<td width="22%" valign="baseline" class="vncell">&nbsp;</td>
-					<td width="78%" class="vtable">
-						<?=gettext("Open a"); ?> <?=$g['[product_name']?> <?=gettext("configuration XML file and click the button below to restore the configuration."); ?>
+					<td>&nbsp;</td>
+					<td>
+						<?=gettext("Open a")?><?=$g['[product_name']?><?=gettext("configuration XML file and click the button below to restore the configuration.")?>
 						<br /><br />
-						<?=gettext("Restore area:"); ?> <?php spit_out_select_items("restorearea", true); ?>
+						<?=gettext("Restore area:")?><?php spit_out_select_items("restorearea", true)?>
 						<p><input name="conffile" type="file" class="formbtn" id="conffile" size="40" /></p>
 						<table>
 							<tr>
@@ -727,14 +652,14 @@ function backuparea_change(obj) {
 									<input name="decrypt" type="checkbox" class="formcheckbox" id="nopackages" onclick="decrypt_change()" />
 								</td>
 								<td>
-									<span class="vexpl"><?=gettext("Configuration file is encrypted."); ?></span>
+									<span><?=gettext("Configuration file is encrypted.")?></span>
 								</td>
 							</tr>
 						</table>
-						<table id="decrypt_opts">
+						<table>
 							<tr>
 								<td>
-									<span class="vexpl"><?=gettext("Password :"); ?></span>
+									<span><?=gettext("Password :")?></span>
 								</td>
 								<td>
 									<input name="decrypt_password" type="password" class="formfld pwd" size="20" value="" />
@@ -742,41 +667,41 @@ function backuparea_change(obj) {
 							</tr>
 							<tr>
 								<td>
-									<span class="vexpl"><?=gettext("confirm :"); ?></span>
+									<span><?=gettext("confirm :")?></span>
 								</td>
 								<td>
 									<input name="decrypt_passconf" type="password" class="formfld pwd" size="20" value="" />
 								</td>
 							</tr>
 						</table>
-						<p><input name="Submit" type="submit" class="formbtn" id="restore" value="<?=gettext("Restore configuration"); ?>" /></p>
-						<p><strong><span class="red"><?=gettext("Note:"); ?></span></strong><br /><?=gettext("The firewall will reboot after restoring the configuration."); ?><br /></p>
+						<p><input name="Submit" type="submit" class="formbtn" id="restore" value="<?=gettext("Restore configuration")?>" /></p>
+						<p><strong><span><?=gettext("Note:")?></span></strong><br /><?=gettext("The firewall will reboot after restoring the configuration.")?><br /></p>
 					</td>
 				</tr>
-				<?php if (($config['installedpackages']['package'] != "") || (is_subsystem_dirty("packagelock"))) { ?>
+				<?php if (($config['installedpackages']['package'] != "") || (is_subsystem_dirty("packagelock"))) {?>
 				<tr>
-					<td colspan="2" class="list" height="12">&nbsp;</td>
+					<td>&nbsp;</td>
 				</tr>
 				<tr>
-					<td colspan="2" class="listtopic"><?=gettext("Package Functions"); ?></td>
+					<td><?=gettext("Package Functions")?></td>
 				</tr>
 				<tr>
-					<td width="22%" valign="baseline" class="vncell">&nbsp;</td>
-					<td width="78%" class="vtable">
-						<?php if ($config['installedpackages']['package'] != "") { ?>
-							<p><?=gettext("Click this button to reinstall all system packages.  This may take a while."); ?> <br /><br />
-							<input name="Submit" type="submit" class="formbtn" id="reinstallpackages" value="<?=gettext("Reinstall packages"); ?>" />
+					<td>&nbsp;</td>
+					<td>
+						<?php if ($config['installedpackages']['package'] != "") {?>
+							<p><?=gettext("Click this button to reinstall all system packages.  This may take a while.")?><br /><br />
+							<input name="Submit" type="submit" class="formbtn" id="reinstallpackages" value="<?=gettext("Reinstall packages")?>" />
 							<br />
 							<br />
-						<?php } ?>
-						<?php if (is_subsystem_dirty("packagelock")) { ?>
-							<p><?=gettext("Click this button to clear the package lock if a package fails to reinstall properly after an upgrade."); ?> <br /><br />
-							<input name="Submit" type="submit" class="formbtn" id="clearpackagelock" value="<?=gettext("Clear Package Lock"); ?>" />
-						<?php } ?>
+						<?php }?>
+						<?php if (is_subsystem_dirty("packagelock")) {?>
+							<p><?=gettext("Click this button to clear the package lock if a package fails to reinstall properly after an upgrade.")?><br /><br />
+							<input name="Submit" type="submit" class="formbtn" id="clearpackagelock" value="<?=gettext("Clear Package Lock")?>" />
+						<?php }?>
 							</p>
 					</td>
 				</tr>
-				<?php } ?>
+				<?php }?>
 			</table>
 			</div>
 		</td>
@@ -784,19 +709,11 @@ function backuparea_change(obj) {
 </table>
 </form>
 
-<script type="text/javascript">
-//<![CDATA[
-encrypt_change();
-decrypt_change();
-//]]>
-</script>
-
-<?php include("fend.inc"); ?>
+<?php include("fend.inc")?>
 </body>
 </html>
 <?php
 
 if (is_subsystem_dirty('restore'))
 	system_reboot();
-
-?>
+?>
\ No newline at end of file
diff --git a/usr/local/www/fend.inc b/usr/local/www/fend.inc
index 9982130813..10544fdbf0 100755
--- a/usr/local/www/fend.inc
+++ b/usr/local/www/fend.inc
@@ -15,4 +15,5 @@
 </footer>
 
 <script src="/jquery/jquery-1.11.1.min.js"></script>
+<script src="/jquery/jquery-ui-1.11.2.min.js"></script>
 <script src="/bootstrap/js/bootstrap.min.js"></script>
\ No newline at end of file
diff --git a/usr/local/www/firewall_nat.php b/usr/local/www/firewall_nat.php
index 0a373ba1a7..56451f9383 100644
--- a/usr/local/www/firewall_nat.php
+++ b/usr/local/www/firewall_nat.php
@@ -108,7 +108,7 @@ if (isset($_POST['del_x'])) {
 			// Check for filter rule associations
 			if (isset($a_nat[$rulei]['associated-rule-id'])){
 				delete_id($a_nat[$rulei]['associated-rule-id'], $config['filter']['rule']);
-				
+
 				mark_subsystem_dirty('filter');
 			}
 	        unset($a_nat[$rulei]);
@@ -172,6 +172,7 @@ echo "<script type=\"text/javascript\" src=\"/javascript/domTT/domTT.js\"></scri
 echo "<script type=\"text/javascript\" src=\"/javascript/domTT/behaviour.js\"></script>";
 echo "<script type=\"text/javascript\" src=\"/javascript/domTT/fadomatic.js\"></script>";
 
+//FIXME This largely matches firewall_rules.php
 ?>
 </head>
 
@@ -226,8 +227,8 @@ echo "<script type=\"text/javascript\" src=\"/javascript/domTT/fadomatic.js\"></
 		  </td>
 		</tr>
 	<?php $nnats = $i = 0; foreach ($a_nat as $natent): ?>
-	<?php 
-	
+	<?php
+
 		//build Alias popup box
 		$span_end = "</U></span>";
 
@@ -257,9 +258,9 @@ echo "<script type=\"text/javascript\" src=\"/javascript/domTT/fadomatic.js\"></
 			$textss = "<span>";
 
 		$textse = "</span>";
-	
+
 		/* if user does not have access to edit an interface skip on to the next record */
-		if(!have_natpfruleint_access($natent['interface'])) 
+		if(!have_natpfruleint_access($natent['interface']))
 			continue;
 	?>
                 <tr valign="top" id="fr<?=$nnats;?>">
diff --git a/usr/local/www/firewall_nat_out.php b/usr/local/www/firewall_nat_out.php
index 23bf8fe7c1..077db6736c 100644
--- a/usr/local/www/firewall_nat_out.php
+++ b/usr/local/www/firewall_nat_out.php
@@ -214,6 +214,8 @@ if (isset($_POST['del_x'])) {
 $pgtitle = array(gettext("Firewall"),gettext("NAT"),gettext("Outbound"));
 include("head.inc");
 
+//FIXME This largely matches firewall_rules.php
+
 ?>
 <body link="#0000CC" vlink="#0000CC" alink="#0000CC">
 <?php include("fbegin.inc"); ?>
diff --git a/usr/local/www/guiconfig.inc b/usr/local/www/guiconfig.inc
index ed2934b432..76e236ba80 100644
--- a/usr/local/www/guiconfig.inc
+++ b/usr/local/www/guiconfig.inc
@@ -1064,6 +1064,18 @@ function rule_columns_with_alias($src, $srcport, $dst, $dstport){
 	}
 }
 
+function form_output_row($name, $label, $content){
+var_dump($content);die;
+?>
+<div class="form-group">
+	<label for="<?=$name?>" class="col-sm-2 control-label"><?=gettext($label); ?></label>
+	<div class="col-sm-10">
+		<?=$content?>
+	</div>
+</div>
+<?php
+}
+
 $timezone = $config['system']['timezone'];
 if (!$timezone)
 	$timezone = "Etc/UTC";
diff --git a/usr/local/www/index.php b/usr/local/www/index.php
index b56046d1b6..2c36efd68a 100644
--- a/usr/local/www/index.php
+++ b/usr/local/www/index.php
@@ -258,17 +258,20 @@ pfSense_handle_custom_code("/usr/local/pkg/dashboard/pre_dashboard");
 <div class="panel panel-default">
 	<div class="panel-heading"><h3><?=gettext("Available Widgets"); ?></h3></div>
 	<div class="panel-body">
-<?php
-	foreach($widgets as $widgetname => $widgetconfig):
-?>
+<?php foreach($widgets as $widgetname => $widgetconfig): ?>
 		<div class="col-sm-3"><a href="#"><i class="icon icon-plus"></i> <?=$widgetconfig['name']?></a></div>
 <?php endforeach; ?>
 	</div>
 </div>
 
-<div class="panel panel-default">
-	<div class="panel-heading"><h3><?=gettext("Welcome to the Dashboard page"); ?>!</h3></div>
-	<div class="panel-body">
+<div class="modal fade">
+<div class="modal-dialog">
+<div class="modal-content">
+	<div class="modal-header">
+		<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
+		<h4 class="modal-title"><?=gettext("Welcome to the Dashboard page"); ?>!</h4>
+	</div>
+	<div class="modal-body">
 		<p>
 			<?=gettext("This page allows you to customize the information you want to be displayed!");?>
 			<?=gettext("To get started click the");?> FIXME <?=gettext("icon to add widgets.");?><br />
@@ -276,6 +279,11 @@ pfSense_handle_custom_code("/usr/local/pkg/dashboard/pre_dashboard");
 			<?=gettext("You can move any widget around by clicking and dragging the title.");?>
 		</p>
 	</div>
+	<div class="modal-footer">
+		<button type="button" class="btn btn-default btn-primary" data-dismiss="modal">Close</button>
+	</div>
+</div>
+</div>
 </div>
 
 <?php
@@ -288,12 +296,17 @@ foreach ($widgets as $widgetname => $widgetconfig){
 				<?=$widgetconfig['name']?>
 				<span style="float: right">
 					<a href="#"><i class="icon icon-wrench"></i></a>
-					<a href="#"><i class="icon icon-plus-sign"></i></a>
-					<a href="#"><i class="icon icon-minus-sign"></i></a>
+					<a data-toggle="collapse" href="#widget-<?=$widgetname?>">
+						<?php if ($widgetconfig['display'] == 'close'): ?>
+							<i class="icon icon-plus-sign"></i>
+						<?php else: ?>
+							<i class="icon icon-minus-sign"></i>
+						<?php endif; ?>
+					</a>
 					<a href="#"><i class="icon icon-remove-sign"></i></a>
 				</span>
 			</div>
-			<div class="panel-body">
+			<div class="panel-body collapse<?=($widgetconfig['display']=='close' ? '' : ' in')?>" id="widget-<?=$widgetname?>">
 				<?php include('/usr/local/www/widgets/widgets/'. $widgetname.'.widget.php'); ?>
 			</div>
 		</div>
diff --git a/usr/local/www/widgets/javascript/gmirror_status.js b/usr/local/www/widgets/javascript/gmirror_status.js
new file mode 100644
index 0000000000..ae3c5da7fe
--- /dev/null
+++ b/usr/local/www/widgets/javascript/gmirror_status.js
@@ -0,0 +1,14 @@
+function gmirrorStatusUpdateFromServer(){
+	$.ajax({
+		type: 'GET',
+		url: '/widgets/widgets/gmirror_status.widget.php',
+		dataType: 'html',
+		success: function(data){
+			$('#gmirror_status').html(data);
+		}
+	});
+}
+
+$(document).ready(function(){
+	setInterval('gmirrorStatusUpdateFromServer()', 60*1000);
+});
\ No newline at end of file
diff --git a/usr/local/www/widgets/javascript/ntp_status.js b/usr/local/www/widgets/javascript/ntp_status.js
index a837bdff57..bca6ea99ca 100644
--- a/usr/local/www/widgets/javascript/ntp_status.js
+++ b/usr/local/www/widgets/javascript/ntp_status.js
@@ -5,7 +5,6 @@ function ntpWidgetUpdateFromServer(){
 		data: 'updateme=yes',
 		dataType: 'html',
 		success: function(data){
-			console.log(data);
 			$('#ntp_status_widget').html(data);
 		}
 	});
@@ -15,7 +14,7 @@ function ntpWidgetUpdateDisplay(){
 	// Javascript handles overflowing
 	ntpServerTime.setSeconds(ntpServerTime.getSeconds()+1);
 
-	$('#ntpStatusClock').html(ntpServerTime);
+	$('#ntpStatusClock').html(ntpServerTime.toString());
 }
 
 $(document).ready(function(){
diff --git a/usr/local/www/widgets/widgets/gmirror_status.widget.php b/usr/local/www/widgets/widgets/gmirror_status.widget.php
index f9711eb0dd..c692ad7156 100644
--- a/usr/local/www/widgets/widgets/gmirror_status.widget.php
+++ b/usr/local/www/widgets/widgets/gmirror_status.widget.php
@@ -32,21 +32,7 @@ $nocsrf = true;
 require_once("guiconfig.inc");
 require_once("gmirror.inc");
 
-if ($_GET['textonly'] == "true") {
-	header("Cache-Control: no-cache");
-	echo gmirror_html_status();
-	exit;
-}
 ?>
-<table>
-	<tbody id="gmirror_status_table">
-		<?php echo gmirror_html_status(); ?>
-	</tbody>
-</table>
-
-<script type="text/javascript">
-//<![CDATA[
-	var gmirrorupdater = new Ajax.PeriodicalUpdater('gmirror_status_table', '/widgets/widgets/gmirror_status.widget.php?textonly=true',
-	{ method: 'get', frequency: 5 } );
-//]]>
-</script>
+<div id="gmirror_status">
+	<?=gmirror_html_status()?>
+</div>
\ No newline at end of file
diff --git a/usr/local/www/widgets/widgets/ntp_status.widget.php b/usr/local/www/widgets/widgets/ntp_status.widget.php
index fb608d5c1d..adaea63df8 100644
--- a/usr/local/www/widgets/widgets/ntp_status.widget.php
+++ b/usr/local/www/widgets/widgets/ntp_status.widget.php
@@ -140,7 +140,7 @@ if (isset($config['ntpd']['gps']['type']) && ($config['ntpd']['gps']['type'] ==
 		<td id="ntpStatusClock">
 			<script>var ntpServerTime = new Date('<?=date_format(date_create(), 'c')?>');</script>
 			<!-- display initial value before javascript takes over -->
-			<?=date_format(date_create(), 'D j Y H:i:s \G\M\T O (T)');?>
+			<?=gmdate('D j Y H:i:s \G\M\T O (T)');?>
 		</td>
 	</tr>
 	<tr>
diff --git a/usr/local/www/widgets/widgets/services_status.widget.php b/usr/local/www/widgets/widgets/services_status.widget.php
index 823c0256e0..7ece14e9ad 100644
--- a/usr/local/www/widgets/widgets/services_status.widget.php
+++ b/usr/local/www/widgets/widgets/services_status.widget.php
@@ -60,6 +60,7 @@ if(isset($_POST['servicestatusfilter'])) {
 <table class="table table-striped">
 <thead>
 	<tr>
+		<th></th>
 		<th>Service</td>
 		<th>Description</td>
 		<th>Action</td>
@@ -81,7 +82,8 @@ if (count($services) > 0) {
 		$service_desc = explode(".",$service['description']);
 ?>
 		<tr>
-			<th><i class="icon icon-<?=get_service_status($service)? 'ok' : 'remove'?>"></i> <?=$service['name']?></th>
+			<td><i class="icon icon-<?=get_service_status($service)? 'ok' : 'remove'?>-sign"></i></td>
+			<td><?=$service['name']?></td>
 			<td><?=$service_desc[0]?></td>
 			<td><?=get_service_control_links($service)?></td>
 		</tr>
diff --git a/usr/local/www/widgets/widgets/smart_status.widget.php b/usr/local/www/widgets/widgets/smart_status.widget.php
index 1a18a46807..f350308edb 100644
--- a/usr/local/www/widgets/widgets/smart_status.widget.php
+++ b/usr/local/www/widgets/widgets/smart_status.widget.php
@@ -33,43 +33,45 @@ require_once("functions.inc");
 require_once("/usr/local/www/widgets/include/smart_status.inc");
 ?>
 
-<table>
-	<tr>
-		<td class="widgetsubheader" align="center"><b><?php echo gettext("Drive") ?></b></td>
-		<td class="widgetsubheader" align="center"><b><?php echo gettext("Ident") ?></b></td>
-		<td class="widgetsubheader" align="center"><b><?php echo gettext("SMART Status") ?></b></td>
-	</tr>
-
+<table class="table table-striped">
+	<thead>
+		<tr>
+			<th></th>
+			<th><?=gettext("Drive")?></th>
+			<th><?=gettext("Ident")?></th>
+			<th><?=gettext("SMART Status")?></th>
+		</tr>
+	</thead>
+	<tbody>
 <?php
 $devs = array();
 ## Get all adX, daX, and adaX (IDE, SCSI, and AHCI) devices currently installed
 $devs = get_smart_drive_list();
 
-if(count($devs) > 0)  {
-	foreach($devs as $dev)  {	## for each found drive do
-		$dev_ident = exec("diskinfo -v /dev/$dev | grep ident	| awk '{print $1}'"); ## get identifier from drive
-		$dev_state = trim(exec("smartctl -H /dev/$dev | awk -F: '/^SMART overall-health self-assessment test result/ {print $2;exit}
+foreach($devs as $dev):
+	$dev_ident = exec("diskinfo -v /dev/$dev | grep ident	| awk '{print $1}'"); ## get identifier from drive
+	$dev_state = trim(exec("smartctl -H /dev/$dev | awk -F: '/^SMART overall-health self-assessment test result/ {print $2;exit}
 /^SMART Health Status/ {print $2;exit}'")); ## get SMART state from drive
-		switch ($dev_state) {
+	switch ($dev_state) {
 		case "PASSED":
 		case "OK":
-			$color = "#90EE90";
+			$icon = 'ok';
 			break;
 		case "":
 			$dev_state = "Unknown";
-			$color = "#C0B788";
+			$icon = 'question';
 			break;
 		default:
-			$color = "#F08080";
+			$icon = 'remove';
 			break;
-		}
+	}
 ?>
 		<tr>
-			<td class="listlr"><?php echo $dev; ?></td>
-			<td class="listr" align="center"><?php echo $dev_ident; ?></td>
-			<td class="listr" align="center"><span style="background-color:<?php echo $color; ?>">&nbsp;<?php echo $dev_state; ?>&nbsp;</span></td>
+			<td><i class="icon icon-<?=$icon?>-sign"></i></td>
+			<td><?=$dev?></td>
+			<td><?=$dev_ident?></td>
+			<td><?=ucfirst($dev_state)?></td>
 		</tr>
-<?php	}
-}
-?>
+<?php endforeach; ?>
+	</tbody>
 </table>
